设为首页收藏本站

晓东CAD家园-论坛

 找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 95|回复: 9

关于CAD自定义线型(带文字线型)文字方向的问题【已解决】

[复制链接]

已领礼包: 26个

财富等级: 恭喜发财

发表于 2020-7-23 13:19:54 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有帐号?立即注册

x
本帖最后由 yakui 于 2020-7-25 23:16 编辑

在使用CAD自定义线型(带文字线型)的时候,线型中的文字会根据划线方向的不同而进行旋转,现在需要将文字放线固定成水平或者向左?
如图: Snipaste_2020-07-23_12-03-01.jpg
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!

已领礼包: 19个

财富等级: 恭喜发财

发表于 2020-7-23 18:03:19 | 显示全部楼层
必须是这样的,才是正确的,符合逻辑的,你绘制的曲线方向不同

你把曲线反向下,就OK了
曲线反向  搜索下论坛
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 5895个

财富等级: 富甲天下

发表于 2020-7-24 00:14:37 | 显示全部楼层
关于CAD自定义线型(带文字线型)文字方向的问题
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 26个

财富等级: 恭喜发财

 楼主| 发表于 2020-7-24 00:21:09 | 显示全部楼层
Lisphk 发表于 2020-7-23 18:03
必须是这样的,才是正确的,符合逻辑的,你绘制的曲线方向不同

你把曲线反向下,就OK了

但是在实际使用过程中很不方便,有时候得画好了,重新描一遍
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 20个

财富等级: 恭喜发财

发表于 2020-7-24 00:46:30 | 显示全部楼层
本帖最后由 marting 于 2020-7-24 00:51 编辑
yakui 发表于 2020-7-24 00:21
但是在实际使用过程中很不方便,有时候得画好了,重新描一遍

你没理解,如果你的一根多段线, 有往左的,其他段有往右的, 那么你怎么定义,都会有上和下的字,因为是一根

如果你就一段,那么你可以根据需要,反向曲线去解决
如果多个段,你怎么也没办法的,因为是一根
或者,如果多段线,你炸开,变成每一段,然后根据需要反向, 但圆,椭圆什么的你没办法

或者,就是别用线型了,写代码,去加字

论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 20个

财富等级: 恭喜发财

发表于 2020-7-24 01:20:30 | 显示全部楼层
文字遮罩阵列.gif

几行代码就OK了,晓东工具箱里面有现成的


  1. (defun c:tt ()
  2.   (xdrx-begin)
  3.   (if (and (setq e (car (xdrx-entsel "\n选择文字<退出>:")))
  4.            (setq e1 (car (xdrx-entsel "\n选择曲线<退出>:"
  5.                                       '((0 . "*line,arc,circle,ellipse"))
  6.                          )
  7.                     )
  8.            )
  9.            (setq dist (getreal "\n输入字间距<退出>:"))
  10.       )
  11.     (progn (setq box          (xdrx-points-ucs2wcs (xdrx-entity-box e))
  12.                  xdir (xdrx-vector-normalize (mapcar '- (cadr box) (car box))
  13.                                                  
  14.                           )
  15.                  ydir (xdrx-vector-perpvector xdir)
  16.                  zdir (xdrx-vector-crossproduct xdir ydir)
  17.                  pts          (xdrx-getpropertyvalue e1 "getpointsatdist" dist)
  18.            )
  19.       (mapcar '(lambda(x)
  20.                  (setq vx (xdrx-getpropertyvalue e1 "firstderiv" x)
  21.                        vy (xdrx-vector-perpvector vx)
  22.                        vz (xdrx-vector-crossproduct vx vy)
  23.                        mat (xdrx-matrix-aligncoordsys (list (xd::geom:get9pt box 5) xdir ydir zdir)
  24.                                                       (list x vx vy vz)))
  25.                  (xdrx-entity-transformedcopy e mat)) pts)
  26.     )
  27.   )
  28.   (xdrx-end)
  29.   (princ)
  30. )



论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 26个

财富等级: 恭喜发财

 楼主| 发表于 2020-7-24 08:27:29 | 显示全部楼层
marting 发表于 2020-7-24 01:20
几行代码就OK了,晓东工具箱里面有现成的

谢谢你的热心回复,一直没想到用代码解决,只奔着线型这条路在走了。走入死胡同。感谢~~~
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 22个

财富等级: 恭喜发财

发表于 2020-7-24 10:57:59 | 显示全部楼层
你可以试试修改一下这个线型的定义,调整文字角度定义,看哪种适合你的要求。详细请查阅自定义线型的帮助文档
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 26个

财富等级: 恭喜发财

 楼主| 发表于 2020-7-25 23:15:54 | 显示全部楼层
e2002 发表于 2020-7-24 10:57
你可以试试修改一下这个线型的定义,调整文字角度定义,看哪种适合你的要求。详细请查阅自定义线型的帮助文 ...

非常谢谢你的提醒,查看了帮助文件,解决了问题。
将旋转角度的前缀由原来的R=改为U=就解决问题了。
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

发表于 2020-8-6 10:37:21 | 显示全部楼层
认真学习。
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|小黑屋|手机版|Archiver|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )  

GMT+8, 2021-1-28 01:01 , Processed in 0.152875 second(s), 34 queries , Gzip On, WinCache On.

Powered by Discuz! X3.4

Copyright © 2001-2020, Tencent Cloud.

快速回复 返回顶部 返回列表